<template>
    <v-row
        :class="[
            { 'pt-5 product': $vuetify.breakpoint.smAndDown },
            { product: $vuetify.breakpoint.mdAndUp },
        ]"
    >
        <!-- Image -->
        <v-col cols="12" md="7" class="image-container pa-0">
            <!-- Big image display -->
            <div
                v-if="Object.keys(product).length > 0"
                class="owl-carousel-container"
            >
                <img
                    class="drag-img btn d-none d-md-block"
                    src="~/assets/images/prev-black.png"
                    @click="prevPage"
                />
                <img
                    class="drag-img btn mt-8 d-block d-md-none"
                    src="~/assets/images/prev-black.png"
                    @click="prevPage"
                />

                <div class="card-img justify-center d-md-block">
                    <center>
                        <v-img
                            v-show="pageLoaded"
                            :src="currentImage"
                            width="50%"
                            height="50%"
                        ></v-img>
                    </center>
                </div>
                <!--                 <div class="card-img d-flex justify-center d-block d-md-none">
                    <v-img
                        v-show="pageLoaded"
                        :src="currentImage"
                        max-width="100%"
                    ></v-img>
                </div> -->
                <center>
                    <ul class="thumbnails">
                        <li
                            v-for="(image, index) in product.images"
                            :key="image.id"
                            :class="[
                                'thumbnail-image',
                                activeImage == index ? 'active' : '',
                            ]"
                            @click="activateImage(index)"
                        >
                            <img :src="image.url" />
                        </li>
                    </ul>
                </center>
            </div>

            <loader-carousel
                v-else
                v-show="productLoader"
                :count="1"
                :text="false"
            />
        </v-col>

        <!--Product Detail  -->
        <v-col
            cols="12"
            md="5"
            :class="[
                { 'black-color pl-5 pr-5': $vuetify.breakpoint.smAndDown },
                { 'black-color pl-16 pr-16': $vuetify.breakpoint.mdAndUp },
            ]"
        >
            <v-container>
                <v-row>
                    <!-- Product Name -->
                    <v-col cols="12" md="9">
                        <!-- {{ product }} -->
                        <h2 v-if="!dataLoad">
                            {{ product.brand.name }} {{ product.name }}
                        </h2>
                        <v-skeleton-loader
                            v-if="dataLoad"
                            class="pt-2"
                            :loading="dataLoading"
                            max-width="200"
                            type="text"
                        />
                    </v-col>

                    <!-- Type / Price -->
                    <v-col cols="12" class="pt-0">
                        <!-- Type -->
                        <span v-if="!dataLoad" class="subtitle">{{
                            product.type.name
                        }}</span>
                        <v-skeleton-loader
                            v-if="dataLoad"
                            class="pt-2"
                            :loading="dataLoading"
                            max-width="100"
                            type="text"
                        />
                        <span v-if="!dataLoad">/</span>

                        <!-- Price -->
                        <span v-if="!dataLoad" class="subtitle"
                            >{{ currencyName }}
                            {{ product.pricing[currency].price }}
                            {{ $t('common.retail') }}</span
                        >
                    </v-col>

                    <!--Description | Delivery & Return  -->
                    <v-col cols="12" class="custom-tab">
                        <template>
                            <v-tabs v-model="descriptionModel">
                                <v-tab
                                    v-for="(
                                        menu, index
                                    ) in descriptionAndDelivery"
                                    :key="menu.name"
                                    :href="`#` + menu.name"
                                    class="lowercase"
                                    text
                                    :class="{ 'pl-0': index == 0 }"
                                    :ripple="false"
                                >
                                    {{ menu.text }}
                                </v-tab>
                            </v-tabs>

                            <v-tabs-items v-model="descriptionModel">
                                <!-- Description -->
                                <v-tab-item value="description">
                                    <v-card v-if="!dataLoad" flat>
                                        <v-card-text
                                            class="pl-0"
                                            v-html="product.description"
                                        >
                                            }}</v-card-text
                                        >
                                    </v-card>
                                    <v-skeleton-loader
                                        v-if="dataLoad"
                                        class="pt-2"
                                        :loading="dataLoading"
                                        type="paragraph"
                                    />
                                </v-tab-item>

                                <!-- Delivery & Return -->
                                <v-tab-item value="deliveryAndReturn">
                                    <v-card flat>
                                        <v-card-text class="pl-0">
                                            <p>
                                                {{ deliveryAndReturn }}
                                            </p>
                                        </v-card-text>
                                    </v-card>
                                </v-tab-item>
                            </v-tabs-items>
                        </template>
                    </v-col>

                    <!-- Variants -->
                    <v-col cols="12" class="custom-tab">
                        <p class="font-syne-bold">
                            {{ $t('common.selectVariant') }}
                        </p>
                        <template>
                            <v-radio-group
                                v-if="!dataLoad"
                                v-model="variantSelected"
                            >
                                <v-radio
                                    v-for="(stock, s) in product.stocks"
                                    :key="'stock-' + s"
                                    :label="stock.option_combination"
                                    :value="stock"
                                ></v-radio>
                            </v-radio-group>
                        </template>
                    </v-col>

                    <!-- Add to box button -->
                    <v-col cols="12" class="pb-0">
                        <v-btn
                            v-if="!outOfStock && !dataLoad"
                            class="lowercase br-0 pl-10 pr-10 subscribe-btn"
                            color="badge"
                            :loading="addToBoxLoad"
                            :disabled="disabledLoad"
                            @click="addToBox(product)"
                        >
                            {{
                                product.business_type.id === 1
                                    ? $t('product.addToBox')
                                    : $t('product.addToCart')
                            }}</v-btn
                        >
                        <!-- HYPEBEAST UNLIMITED PLAN ONLY (NOTIFY ME) -->
                        <v-btn
                            v-else-if="planDetails.id === 2"
                            class="lowercase br-0 pl-10 pr-10 subscribe-btn"
                            color="badge"
                            :loading="notifyMeLoad"
                            :disabled="disabledNotifyLoad"
                            @click="notifyMe()"
                            >{{ $t('buttons.notifyMeBtn') }}</v-btn
                        >
                        <v-btn
                            v-else
                            class="lowercase br-0 pl-10 pr-10 subscribe-btn"
                            color="badge"
                            :loading="dataLoad"
                            :disabled="true"
                            >{{ $t('product.outOfStock') }}</v-btn
                        >
                    </v-col>

                    <!-- Add to Favorite hyperlink -->
                    <v-col cols="12" class="pt-2">
                        <v-btn
                            v-if="checkWishlist(product.id) === 'mdi-heart'"
                            text
                            fab
                            :loading="dataLoad"
                            :disabled="dataLoad"
                            @click="removeFromWishlist(product.id)"
                        >
                            <v-icon
                                class="heart-icon-default"
                                v-html="checkWishlist(product.id)"
                            ></v-icon>
                        </v-btn>
                        <v-btn
                            v-else
                            text
                            fab
                            :loading="dataLoad"
                            :disabled="dataLoad"
                            @click="addToWishlist(product.id)"
                        >
                            <v-icon
                                class="heart-icon-default"
                                v-html="checkWishlist(product.id)"
                            ></v-icon>
                        </v-btn>
                    </v-col>
                </v-row>
            </v-container>
        </v-col>
    </v-row>
</template>

<script lang="ts">
import { Vue, Component, Watch } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
import { Debounce } from 'lodash-decorators'
import { ImageMagnifier } from 'vue-image-magnifier'

Vue.use(ImageMagnifier)
Vue.component('ImageMagnifier', ImageMagnifier)

@Component<any>({
    head() {
        return {
            title: this.product.name,
            meta: [
                {
                    hid: 'description',
                    name: 'description',
                    content: this.productDescription,
                },
            ],
        }
    },
    computed: {
        ...mapGetters({
            currency: 'currency/getCurrency',
            currencyName: 'currency/getCurrencyName',
            checkWishlist: 'wishlist/checkWishlist',
            cartItems: 'cart/getCartItems',
            planDetails: 'subscription/getPlanDetails',
            menuDashboard: 'menu/getMenuDashboard',
        }),
    },
})
export default class Product extends Vue {
    pageLoaded: Boolean = false
    cartItems!: any
    menuDashboard!: any
    dataLoad: Boolean = true
    addToBoxLoad: boolean = false
    productLoader: boolean = true
    dataLoading: Boolean = true
    disabledLoad: Boolean = true
    notifyMeLoad: boolean = false
    disabledNotifyLoad: boolean = false
    variantSelected: any = ''
    isSize: boolean = false
    variantSize: any = {} // default
    isColor: boolean = false
    variantColor: any = {} // default
    descriptionModel: string = ''
    productDescription: string = ''
    descriptionAndDelivery: any = [
        { name: 'description', text: this.$t('common.description') },
        { name: 'deliveryAndReturn', text: this.$t('common.deliveryReturn') },
    ]

    deliveryAndReturn: any = this.$t('common.deliveryReturn')
    navigationNext: String = require('~/assets/images/box.png')
    currentImageIndex: number = 0
    product: any = {}
    message: any = null
    color: String = ''
    icon: String = ''
    outOfStock: boolean = false
    activeImage: number = 0
    currentImage: string =
        Object.keys(this.product).length > 0
            ? this.product.images[this.activeImage].url
            : ''

    currentImageWidth: string = 'auto'
    // Methods
    /* nextImage() {
        let active = this.activeImage + 1
        if (active >= this.images.length) {
            active = 0
        }
        this.activateImage(active)
    }

    prevImage() {
        let active = this.activeImage - 1
        if (active < 0) {
            active = this.images.length - 1
        }
        this.activateImage(active)
	} 
	
	changed(event: any) {
        this.currentImageIndex = event.item.index - 2
        if (this.currentImageIndex >= 5) {
            console.log(this.$refs.thumbnail)
        }
    } */

    activateImage(imageIndex) {
        this.activeImage = imageIndex
        this.currentImage = this.product.images[this.activeImage].url
    }

    selectVariant(variant: any = {}) {
        if (variant.inventories_count === 0) {
            this.outOfStock = true
            this.disabledLoad = true
        } else {
            this.disabledLoad = false
            this.outOfStock = false
        }
        this.variantSelected = variant
    }

    prevPage() {
        if (this.product.business_type.id === 1) {
            this.$router.push('/browse')
        } else {
            this.$router.push('/shop')
        }
    }

    notifyMe() {
        this.notifyMeLoad = true
        this.disabledNotifyLoad = true
        // notify product
        this.$api.product
            .notifyMe(this.variantSelected)
            .then((_response) => {
                this.notifyMeLoad = false
                this.disabledNotifyLoad = false

                // Display snackbar
                const val = {
                    text: this.$t('notification.product.notify.success'),
                    color: 'green',
                    icon: 'mdi-check',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)
            })
            .catch((error) => {
                if (error.response?.status === 400) {
                    const val = {
                        text: error.response.data.message,
                        color: 'white',
                        icon: 'mdi-alert',
                    }
                    this.$store.dispatch('snackbar/displaySnackBar', val)
                }
                this.notifyMeLoad = false
                this.disabledNotifyLoad = false
            })
    }

    addToBox(product: any) {
        console.log(product)
        this.addToBoxLoad = true
        this.disabledLoad = true
        // No variants selected
        if (!this.variantSelected) {
            this.addToBoxLoad = false
            this.disabledLoad = false
            const val = {
                text: this.$t('notification.cart.variant.failed'),
                color: 'white',
                icon: 'mdi-alert',
            }
            this.$store.dispatch('snackbar/displaySnackBar', val)
        } else {
            const checkItem = this.cartItems.find(
                (item) => item.id === product.id
            )

            if (!checkItem) {
                const productDetails: any = {}
                productDetails.product = product
                productDetails.variant = this.variantSelected

                // add to cart
                if (product.business_type.id === 1) {
                    this.$api.cart
                        .add(
                            productDetails.product.id,
                            productDetails.variant.id,
                            productDetails.product.type.id,
                            1,
                            1
                        )
                        .then((response) => {
                            this.addToBoxLoad = false
                            this.disabledLoad = false

                            this.$store.dispatch(
                                'cart/addToCart',
                                response.data
                            )

                            // Display snackbar
                            const val = {
                                text: this.$t('notification.cart.added'),
                                color: 'green',
                                icon: 'mdi-check',
                            }
                            this.$store.dispatch(
                                'snackbar/displaySnackBar',
                                val
                            )
                        })
                        .catch((error) => {
                            if (error.response.status === 401) {
                                // Display snackbar
                                const val = {
                                    text: this.$t('auth.unAuthenticate'),
                                    color: 'white',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )
                            }

                            if (error.response?.status === 400) {
                                // Display snackbar
                                const val: {} = {
                                    text: error.response.data.message,
                                    color: 'red',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )

                                this.$router.push(
                                    this.menuDashboard.SUBSCRIPTION.path
                                )
                            }

                            this.addToBoxLoad = false
                            this.disabledLoad = false
                        })
                } else {
                    this.$api.cart
                        .add(
                            productDetails.product.id,
                            productDetails.variant.id,
                            productDetails.product.type.id,
                            1,
                            2
                        )
                        .then(async (response) => {
                            this.addToBoxLoad = false
                            this.disabledLoad = false

                            this.$store.dispatch(
                                'cart/addToCartShop',
                                response.data
                            )

                            const userShopCart =
                                await this.$api.cart.getShopCart()

                            if (userShopCart.data.items.length > 0) {
                                this.$store.dispatch(
                                    'cart/updateCartShop',
                                    userShopCart.data
                                )
                            }

                            this.$router.push(this.$route.path + '?s=true')

                            // Display snackbar
                            const val = {
                                text: this.$t('notification.cart.added'),
                                color: 'green',
                                icon: 'mdi-check',
                            }
                            this.$store.dispatch(
                                'snackbar/displaySnackBar',
                                val
                            )
                            this.variantSelected = ''
                        })
                        .catch((error) => {
                            if (error.response.status === 401) {
                                // Display snackbar
                                const val = {
                                    text: this.$t('auth.unAuthenticate'),
                                    color: 'white',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )
                            }

                            if (error.response?.status === 400) {
                                // Display snackbar
                                const val: {} = {
                                    text: error.response.data.message,
                                    color: 'red',
                                    icon: 'mdi-alert',
                                }
                                this.$store.dispatch(
                                    'snackbar/displaySnackBar',
                                    val
                                )

                                this.$router.push(
                                    this.menuDashboard.SUBSCRIPTION.path
                                )
                            }

                            this.addToBoxLoad = false
                            this.disabledLoad = false
                        })
                }
            } else {
                const val = {
                    text: this.$t('notification.cart.duplicate'),
                    color: 'white',
                    icon: 'mdi-alert',
                }
                this.$store.dispatch('snackbar/displaySnackBar', val)
                this.addToBoxLoad = false
                this.disabledLoad = false
            }
        }
    }

    removeFromBox(product: {}) {
        this.$store.dispatch('cart/removeFromCart', product)
        const val: {} = {
            text: this.$t('notification.cart.removed'),
            color: 'green',
            icon: 'mdi-check',
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    @Watch('variantSelected')
    triggerAction(value) {
        console.log(value)
        this.selectVariant(value)
    }

    @Debounce(500)
    async addToWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.unAuthenticate')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const response = await this.$api.wishlist.addWishlist(id)

            if (response.data) {
                this.$store.dispatch('wishlist/addToWishlist', response.data)
                this.message = this.$t('notification.wishlist.added')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    @Debounce(500)
    async removeFromWishlist(id: number) {
        if (!this.$cookies.get('t')) {
            this.message = this.$t('auth.wishlistAuth')
            this.color = 'red'
            this.icon = 'mdi-close-circle'
        } else {
            const deleteResponse = await this.$api.wishlist.deleteWishlist(id)

            if (deleteResponse) {
                this.$store.dispatch('wishlist/removeFromWishlist', id)
                this.message = this.$t('notification.wishlist.removed')
                this.color = 'green'
                this.icon = 'mdi-check'
            }
        }

        const val = {
            text: this.message,
            color: this.color,
            icon: this.icon,
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)
    }

    // get product
    async getProduct() {
        await this.$api.product
            .product(this.$router.currentRoute.params.slug)
            .then((response) => {
                if (response.data) {
                    this.product = response.data
                    this.currentImage =
                        this.product.images[this.activeImage].url
                    this.productDescription = response.data.description.replace(
                        /(<([^>]+)>)/gi,
                        ''
                    )
                    this.productLoader = false
                    this.dataLoad = false
                    this.dataLoading = false
                }
            })
            .catch((error) => {
                if (error.response.status === 404) {
                    return this.$nuxt.error({
                        statusCode: 404,
                    })
                }
            })
    }

    // Mounted
    mounted() {
        if (process.browser) {
            if (window.innerWidth <= 460) this.currentImageWidth = '100%'
        }

        setTimeout(() => {
            this.pageLoaded = true
        }, 500)

        this.getProduct()
    }
}
</script>
